
`ifdef _VCP
`else
 `define library(a,b)
`endif

`timescale 1ns / 1ns

`ifdef synthesis

 `ifdef INC_BUFG_V
 `else
  `define INC_BUFG_V 1

module BUFG ( I ,O ); 
   parameter InstancePath = "*" ;
   input     I ;
   output    O ;
endmodule
// synthesis atribute BOX_TYPE of BUFG is "BLACK_BOX"

 `endif

 `ifdef INC_CLKDLL_V
 `else
  `define INC_CLKDLL_V 1

module CLKDLL ( CLKFB ,CLKIN ,RST ,
                CLK0 ,CLK180 ,CLK270 ,CLK2X ,
                CLK90 ,CLKDV ,LOCKED ); 
   parameter CLKDV_DIVIDE = 4.5 ;
   parameter InstancePath = "*" ;
   input     CLKFB ;
   input     CLKIN ;
   input     RST ;
   output    CLK0 ;
   output    CLK180 ;
   output    CLK270 ;
   output    CLK2X ;
   output    CLK90 ;
   output    CLKDV ;
   output    LOCKED ;
endmodule
// synthesis atribute BOX_TYPE of CLKDLL is "BLACK_BOX"

 `endif

`endif //  `ifdef synthesis

module codec_clocks_generator(XTAL_CLK, RST,
                              CLK, MCLK, BICK, LRCK);

   input XTAL_CLK;
   input RST;

   wire  XTAL_CLK;
   wire  RST;

   output CLK;
   output MCLK;
   output BICK;
   output LRCK;

   wire   CLK;
   wire   MCLK; 
   wire   BICK; 
   wire   LRCK; 

   wire   feedback_prebuf, feedback_postbuf;
   wire   clkdv_prebuf, clkdv_postbuf;
   
   wire   zero;
   assign zero = 0;

   reg [0:7] divider;

   assign    CLK = feedback_postbuf;
   assign    MCLK = clkdv_postbuf;
   assign    BICK = divider[6];
   assign    LRCK = divider[0];
   
   always @(posedge MCLK)
     begin
        if(RST)
          divider <= 0;
        else
          divider <= divider + 1;
     end

   // synthesis translate_off
   `library("the_dll", "virtex")
   // synthesis translate_on
   CLKDLL the_dll
   	
     (
      .CLKFB(feedback_postbuf),
      .CLKIN(XTAL_CLK),
      .RST(zero),
      .CLK0(feedback_prebuf),
      .CLK180(),
      .CLK270(),
      .CLK2X(),
      .CLK90(),
      .CLKDV(clkdv_prebuf),
      .LOCKED()
      );


   // synthesis translate_off
   `library("feedback_buffer", "virtex")
   // synthesis translate_on
   BUFG feedback_buffer
     (
      .I(feedback_prebuf),
      .O(feedback_postbuf)
      );

   // synthesis translate_off
   `library("clkdv_buffer", "virtex")
   // synthesis translate_on
   BUFG clkdv_buffer
     (
      .I(clkdv_prebuf),
      .O(clkdv_postbuf)
      );

endmodule // codec_clocks
